- hosts: all
  tasks:
    - name: install required packages
      apt: 
        name: "{{ item }}"
        state: present
        update_cache: yes
      with_items:
        - git
        - htop
        - apt-transport-https
        - ca-certificates
        - curl
        - software-properties-common
        - python3-pip
      
    - name: Add Dockers official GPG key
      remote_user: root
      apt_key:
        url: https://download.docker.com/linux/ubuntu/gpg
        state: present
      tags:
        - docker

    - name: Verify that we have the key with the fingerprint
      remote_user: root
      apt_key:
        id: 0EBFCD88
        state: present
      tags:
        - docker

    - name: Set up the stable repository
      remote_user: root
      apt_repository:
        repo: deb [arch=amd64] https://download.docker.com/linux/ubuntu xenial stable
        state: present
        update_cache: yes
      tags:
        - docker

    - name: Update apt packages
      remote_user: root
      apt:
        update_cache: yes
      tags:
        - docker

    - name: Install docker
      remote_user: root
      apt:
        name: docker-ce
        state: present
        update_cache: yes
      tags:
        - docker

    - name: Install Docker Module for Python
      pip:
        name: docker

    - name: Install Docker Compose for Python
      pip:
        name: docker-compose

    - name: Install jsondiff from pip
      pip:
        name: jsondiff

    - name: Add remote "root" user to "docker" group
      remote_user: root
      user:
        name: "root"
        group: "docker"
        append: yes
      tags:
        - docker

    - name: Install docker-compose
      remote_user: root
      get_url: 
        url : https://github.com/docker/compose/releases/download/1.28.2/docker-compose-Linux-x86_64
        dest: /usr/local/bin/docker-compose
        mode: 'u+x,g+x'